osgDB::ObjectWrapper Class Reference

`#include <ObjectWrapper>`

Inheritance diagram for osgDB::ObjectWrapper:

## Public Types

typedef std::vector< BaseSerializer::Type > | TypeList
typedef std::vector< osg::ref_ptr< BaseSerializer > > | SerializerList
typedef std::vector< osg::ref_ptr< FinishedObjectReadCallback > > | FinishedObjectReadCallbackList
typedef std::list< ObjectWrapperAssociate > | RevisionAssociateList
typedef osg::Object * | CreateInstanceFunc()
typedef std::multimap< std::string, osg::ref_ptr< MethodObject > > | MethodObjectMap

## Public Member Functions

| ObjectWrapper (CreateInstanceFunc *createInstanceFunc, const std::string &name, const std::string &associates)
| ObjectWrapper (CreateInstanceFunc *createInstanceFunc, const std::string &domain, const std::string &name, const std::string &associates)
void | setUpdatedVersion (int ver)
int | getUpdatedVersion () const
osg::Object * | createInstance () const
const std::string & | getDomain () const
const std::string & | getName () const
const RevisionAssociateList & | getAssociates () const
SerializerList & | getSerializerList ()
const SerializerList & | getSerializerList () const
TypeList & | getTypeList ()
const TypeList & | getTypeList () const
void | addSerializer (BaseSerializer *s, BaseSerializer::Type t=BaseSerializer::RW_UNDEFINED)
void | markSerializerAsRemoved (const std::string &name)
void | markAssociateAsRemoved (const std::string &name)
void | markAssociateAsAdded (const std::string &name)
BaseSerializer * | getLastSerializer ()
BaseSerializer * | getSerializer (const std::string &name)
BaseSerializer * | getSerializer (const std::string &name, BaseSerializer::Type &type)
void | addFinishedObjectReadCallback (FinishedObjectReadCallback *forc)
bool | read (InputStream &, osg::Object &)
bool | write (OutputStream &, const osg::Object &)
bool | readSchema (const StringList &properties, const TypeList &types)
void | writeSchema (StringList &properties, TypeList &types)
void | resetSchema ()
void | addMethodObject (const std::string &methodName, MethodObject *mo)
MethodObjectMap & | getMethodObjectMap ()
const MethodObjectMap & | getMethodObjectMap () const
void | setupAssociatesRevisionsInheritanceIfRequired ()
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

| ObjectWrapper ()
virtual | ~ObjectWrapper ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Static Protected Member Functions

static void | splitAssociates (const std::string &src, ObjectWrapper::RevisionAssociateList &list, char separator=' ')

## Protected Attributes

CreateInstanceFunc * | _createInstanceFunc
std::string | _domain
std::string | _name
RevisionAssociateList | _associates
SerializerList | _serializers
SerializerList | _backupSerializers
TypeList | _typeList
FinishedObjectReadCallbackList | _finishedObjectReadCallbacks
MethodObjectMap | _methodObjectMap
int | _version
bool | _isAssociatesRevisionsInheritanceDone
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Member Typedef Documentation

## CreateInstanceFunc

typedef osg::Object * osgDB::ObjectWrapper::CreateInstanceFunc()

## FinishedObjectReadCallbackList

typedef std::vector< osg::ref_ptr<FinishedObjectReadCallback> > osgDB::ObjectWrapper::FinishedObjectReadCallbackList

## MethodObjectMap

typedef std::multimap< std::string, osg::ref_ptr<MethodObject> > osgDB::ObjectWrapper::MethodObjectMap

## RevisionAssociateList

typedef std::list<ObjectWrapperAssociate> osgDB::ObjectWrapper::RevisionAssociateList

## SerializerList

typedef std::vector< osg::ref_ptr<BaseSerializer> > osgDB::ObjectWrapper::SerializerList

## TypeList

typedef std::vector< BaseSerializer::Type > osgDB::ObjectWrapper::TypeList

## Constructor & Destructor Documentation

## ObjectWrapper() [1/3]

osgDB::ObjectWrapper::ObjectWrapper | ( | CreateInstanceFunc * | createInstanceFunc,
|  | const std::string & | name,
|  | const std::string & | associates )

## ObjectWrapper() [2/3]

osgDB::ObjectWrapper::ObjectWrapper | ( | CreateInstanceFunc * | createInstanceFunc,
|  | const std::string & | domain,
|  | const std::string & | name,
|  | const std::string & | associates )

## ObjectWrapper() [3/3]

osgDB::ObjectWrapper::ObjectWrapper | ( |  | ) |

inline protected

References _version.

## ~ObjectWrapper()

virtual osgDB::ObjectWrapper::~ObjectWrapper | ( |  | ) |

inline protected virtual

## Member Function Documentation

## addFinishedObjectReadCallback()

void osgDB::ObjectWrapper::addFinishedObjectReadCallback | ( | FinishedObjectReadCallback * | forc | ) |

inline

References _finishedObjectReadCallbacks.

## addMethodObject()

void osgDB::ObjectWrapper::addMethodObject | ( | const std::string & | methodName,
|  | MethodObject * | mo )

## addSerializer()

void osgDB::ObjectWrapper::addSerializer | ( | BaseSerializer * | s,
|  | BaseSerializer::Type | t = BaseSerializer::RW_UNDEFINED )

References osgDB::BaseSerializer::RW_UNDEFINED.

## createInstance()

osg::Object * osgDB::ObjectWrapper::createInstance | ( |  | ) | const

inline

References _createInstanceFunc.

## getAssociates()

const RevisionAssociateList & osgDB::ObjectWrapper::getAssociates | ( |  | ) | const

inline

References _associates.

## getDomain()

const std::string & osgDB::ObjectWrapper::getDomain | ( |  | ) | const

inline

References _domain.

## getLastSerializer()

BaseSerializer * osgDB::ObjectWrapper::getLastSerializer | ( |  | ) |

inline

References _serializers.

## getMethodObjectMap() [1/2]

MethodObjectMap & osgDB::ObjectWrapper::getMethodObjectMap | ( |  | ) |

inline

References _methodObjectMap.

## getMethodObjectMap() [2/2]

const MethodObjectMap & osgDB::ObjectWrapper::getMethodObjectMap | ( |  | ) | const

inline

References _methodObjectMap.

## getName()

const std::string & osgDB::ObjectWrapper::getName | ( |  | ) | const

inline

References _name.

## getSerializer() [1/2]

BaseSerializer * osgDB::ObjectWrapper::getSerializer | ( | const std::string & | name | ) |

## getSerializer() [2/2]

BaseSerializer * osgDB::ObjectWrapper::getSerializer | ( | const std::string & | name,
|  | BaseSerializer::Type & | type )

## getSerializerList() [1/2]

SerializerList & osgDB::ObjectWrapper::getSerializerList | ( |  | ) |

inline

References _serializers.

## getSerializerList() [2/2]

const SerializerList & osgDB::ObjectWrapper::getSerializerList | ( |  | ) | const

inline

References _serializers.

## getTypeList() [1/2]

TypeList & osgDB::ObjectWrapper::getTypeList | ( |  | ) |

inline

References _typeList.

## getTypeList() [2/2]

const TypeList & osgDB::ObjectWrapper::getTypeList | ( |  | ) | const

inline

References _typeList.

## getUpdatedVersion()

int osgDB::ObjectWrapper::getUpdatedVersion | ( |  | ) | const

inline

References _version.

Referenced by osgDB::UpdateWrapperVersionProxy::UpdateWrapperVersionProxy().

## markAssociateAsAdded()

void osgDB::ObjectWrapper::markAssociateAsAdded | ( | const std::string & | name | ) |

## markAssociateAsRemoved()

void osgDB::ObjectWrapper::markAssociateAsRemoved | ( | const std::string & | name | ) |

## markSerializerAsRemoved()

void osgDB::ObjectWrapper::markSerializerAsRemoved | ( | const std::string & | name | ) |

## read()

bool osgDB::ObjectWrapper::read | ( | InputStream & | ,
|  | osg::Object & | )

## readSchema()

bool osgDB::ObjectWrapper::readSchema | ( | const StringList & | properties,
|  | const TypeList & | types )

## resetSchema()

void osgDB::ObjectWrapper::resetSchema | ( |  | ) |

inline

References _backupSerializers, and _serializers.

## setupAssociatesRevisionsInheritanceIfRequired()

void osgDB::ObjectWrapper::setupAssociatesRevisionsInheritanceIfRequired | ( |  | ) |

## setUpdatedVersion()

void osgDB::ObjectWrapper::setUpdatedVersion | ( | int | ver | ) |

inline

References _version.

Referenced by osgDB::UpdateWrapperVersionProxy::UpdateWrapperVersionProxy().

## splitAssociates()

void osgDB::ObjectWrapper::splitAssociates | ( | const std::string & | src,
|  | ObjectWrapper::RevisionAssociateList & | list,
|  | char | separator = ' ' )

static protected

## write()

bool osgDB::ObjectWrapper::write | ( | OutputStream & | ,
|  | const osg::Object & | )

## writeSchema()

void osgDB::ObjectWrapper::writeSchema | ( | StringList & | properties,
|  | TypeList & | types )

## Member Data Documentation

## _associates

RevisionAssociateList osgDB::ObjectWrapper::_associates

protected

Referenced by getAssociates().

## _backupSerializers

SerializerList osgDB::ObjectWrapper::_backupSerializers

protected

Referenced by resetSchema().

## _createInstanceFunc

CreateInstanceFunc* osgDB::ObjectWrapper::_createInstanceFunc

protected

Referenced by createInstance().

## _domain

std::string osgDB::ObjectWrapper::_domain

protected

Referenced by getDomain().

## _finishedObjectReadCallbacks

FinishedObjectReadCallbackList osgDB::ObjectWrapper::_finishedObjectReadCallbacks

protected

Referenced by addFinishedObjectReadCallback().

## _isAssociatesRevisionsInheritanceDone

bool osgDB::ObjectWrapper::_isAssociatesRevisionsInheritanceDone

protected

## _methodObjectMap

MethodObjectMap osgDB::ObjectWrapper::_methodObjectMap

protected

Referenced by getMethodObjectMap(), and getMethodObjectMap().

## _name

std::string osgDB::ObjectWrapper::_name

protected

Referenced by getName().

## _serializers

SerializerList osgDB::ObjectWrapper::_serializers

protected

Referenced by getLastSerializer(), getSerializerList(), getSerializerList(), and resetSchema().

## _typeList

TypeList osgDB::ObjectWrapper::_typeList

protected

Referenced by getTypeList(), and getTypeList().

## _version

int osgDB::ObjectWrapper::_version

protected

Referenced by getUpdatedVersion(), ObjectWrapper(), and setUpdatedVersion().

The documentation for this class was generated from the following file:

- ObjectWrapper